#include <iostream>
#include <vector>

using namespace std;

int n,o,a,b,ab;
class Covek {
    public:
        string grupa;
        int potrebno;
        int dato[4];
        Covek(string grupa, int potrebno) {
            this->grupa = grupa;
            this->potrebno = potrebno;
            for(int i = 0; i < 4; i++) {
                dato[i] = 0;
            }
        }
};

void daj_coveku_ab(Covek* covek) {
    int dato = min(covek->potrebno,ab);
    covek->potrebno -= dato;
    covek->dato[3] += dato;
    ab -= dato;
}
void daj_coveku_b(Covek* covek) {
    int dato = min(covek->potrebno,b);
    covek->potrebno -= dato;
    covek->dato[2] += dato;
    b -= dato;
}
void daj_coveku_a(Covek* covek) {
    int dato = min(covek->potrebno,a);
    covek->potrebno -= dato;
    covek->dato[1] += dato;
    a -= dato;
}
void daj_coveku_o(Covek* covek) {
    int dato = min(covek->potrebno,o);
    covek->potrebno -= dato;
    covek->dato[0] += dato;
    o -= dato;
}

bool da_li_je_moguce(vector<Covek*> ljudi) {
    for(Covek* covek : ljudi) {
        if(covek->potrebno > 0) return false;
    }
    return true;
}

int main() {
    cin>>n;
    cin>>o>>a>>b>>ab;
    vector<Covek*> ljudi;
    for(int i = 0; i < n; i++) {
        string grupa;
        int potrebno;
        cin>>grupa;
        cin>>potrebno;
        Covek *covek = new Covek(grupa,potrebno);
        ljudi.push_back(covek);
    }
    for(Covek* covek : ljudi) {
        if(covek->grupa == "AB") {
            daj_coveku_ab(covek);
            daj_coveku_a(covek);
            daj_coveku_b(covek);
            daj_coveku_o(covek);
            if(ab == 0 && a==0 && b==0 && o==0) break;
        }
    }
    for(Covek* covek : ljudi) {
        if(covek->grupa == "B") {
            daj_coveku_b(covek);
            daj_coveku_o(covek);
            if(b == 0 && o == 0) break;
        }
    }
    for(Covek* covek : ljudi) {
        if(covek->grupa == "A") {
            daj_coveku_a(covek);
            daj_coveku_o(covek);
            if(a == 0 && o == 0) break;
        }
    }
    for(Covek* covek : ljudi) {
        if(covek->grupa == "O") {
            daj_coveku_o(covek);
            if(o == 0) break;
        }
    }
    if(da_li_je_moguce(ljudi)) {
        cout<<"moguce"<<endl;
        for(Covek* covek : ljudi) {
            cout<<covek->dato[0]<<" "<<covek->dato[1]<<" "<<covek->dato[2]<<" "<<covek->dato[3]<<endl;
        }
    } else cout<<"nemoguce"<<endl;
}